'use strict';
const _ = require('lodash');
const requestJSON = require('request-json');

module.exports = class Client {
  static upxClient(env, options) {
    let conf = _.defaultsDeep(options || {}, Client.getConfig(env).rpc);
    //return new rackport.TBHTTPClient(conf);
    let upxRPCClient = requestJSON.createClient(conf.url);
    return {
      request: function(method, params) {
        return new Promise(function(resolve, reject) {
          return upxRPCClient.post(process.env.UPX_MODE === 'ISV' ? '' : '/api/rpc', {
            id: Date.now(),
            method: method,
            params: params
          }).then((res)=> {
            const result = res.body.result;
            const error = res.body.error;
            if (error) {
              error.message = error.message.split('-').slice(1).join('-');
              reject(error);
              return;
            }
            resolve(result);
          });
        });
      }
    };
  }

  static getConfig(env) {
    return require(`../config/${env}`);
  }
};
